<template>
    <div>
        <breadcrumb-component title="Grades/Variações" :pages="breadPages"/>

        <panel-component title="Lista de grades" length="8">
            <div class="form-group col-md-6">
                <router-link class="btn btn-primary" :to="{name: 'grids.create'}">
                    <i class="fa fa-plus-circle"></i> Cadastrar grades/variações
                </router-link>
            </div>
            <div class="table-responsive col-md-12">
                <table class="table table-striped table-hover table-bordered">
                    <thead>
                    <tr>
                        <th>Nome grade)</th>
                        <th>Variações</th>
                        <th class="text-center" style="width: 130px">Ação</th>
                    </tr>
                    </thead>
                    <tbody>
                    <tr v-for="(grid, index) in this.grids.items" :key="index">
                        <td>{{grid.name}}</td>
                        <td>
                            <span v-for="variation in grid.variations" class="label label-primary">
                                {{variation.name}}
                            </span>
                        </td>
                        <td class="text-center">
                            <router-link
                                    :to="{name: 'grids.edit', params: {id: grid.id}}"
                                    class="btn btn-xs btn-info ">
                                <i class="fa fa-pencil"></i>
                            </router-link>
                            <button class="btn btn-xs btn-danger" @click.prevent="confirmDestroy(grid)">
                                <i class="fa fa-remove"></i>
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </panel-component>
    </div>
</template>

<script>
    export default {
        data() {
            return {
                breadPages: [
                    {link: 'dashboard', name: 'Dashboard', active: false},
                    {link: 'grids', name: 'Grades/variações', active: false},
                    {link: 'grids', name: 'Listar', active: true},
                ]
            }
        },

        created() {
            this.loadGrids()
        },

        computed: {
            grids() {
                return this.$store.state.grids
            }
        },

        methods: {
            loadGrids() {
                this.$store.dispatch('loadGrids')
            },

            confirmDestroy(grid) {
                this.$snotify.confirm(`Deseja realmente apagar a grade: ${grid.name} ?`, 'Deletar ?', {
                    timeout: 5000,
                    showProgressBar: true,
                    closeOnClick: false,
                    pauseOnHover: true,
                    buttons: [
                        {
                            text: 'Sim', action: (toast) => {
                            this.$snotify.remove(toast.id)
                            this.destroyGrid(grid.id)
                        }
                        },
                        {
                            text: 'Não', action: (toast) => {
                            console.log('Clicked: No');
                            this.$snotify.remove(toast.id)
                        }
                        },
                    ]
                })
            },

            destroyGrid(id) {
                this.$store.dispatch('destroyGrid', id)
                    .then(() => {
                        this.loadGrids()
                        this.$snotify.success('Grade apagada com sucesso!', 'Sucesso')
                    })
                    .catch(() => {
                        this.$snotify.error('Não foi possível apagar a grade!', 'Error')
                    })
            }
        }
    }
</script>

<style scoped="">
    .label {
        margin-right: 5px;
    }
</style>